;  .

	.686
	.model flat, stdcall
	option casemap :none

	include \masm32\include\ntdll.inc
	includelib \masm32\lib\ntdll.lib

NTID struct
	Rva		PVOID ?
	Id		USHORT ?
	S1ze		USHORT ?	;  .
	Nam3		CHAR 1 DUp (?)
NTID ends
PNTID typedef ptr NTID

.data
PUBLIC g_Init
PUBLIC g_NtBase
PUBLIC g_NtView
PUBLIC g_NtList
PUBLIC g_NtListN

g_Init		BOOLEAN FALSE
g_NtBase		PVOID ?	;  ntdll.
g_NtView		PVOID ?	;      ntdll.
g_NtList		PNTID ?	;  . 
g_NtListN		ULONG ?	;  .
	
.code
%GET_CURRENT_GRAPH_ENTRY macro
	Call GetGraphReference
endm

%GET_GRAPH_ENTRY macro PGET_CURRENT_GRAPH_ENTRY
	Call PGET_CURRENT_GRAPH_ENTRY
endm

%GET_GRAPH_REFERENCE macro
GetGraphReference::
	pop eax
	ret
endm

	%GET_GRAPH_REFERENCE

	assume fs:nothing
%GET_NT_BASE macro Reg32
	mov Reg32,fs:[TEB.Peb]
	mov Reg32,PEB.Ldr[Reg32]
	mov Reg32,PEB_LDR_DATA.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.InLoadOrderModuleList.Flink[Reg32]
	mov Reg32,LDR_DATA_TABLE_ENTRY.DllBase[Reg32]	; ntdll.dll
endm

LdrGetNtBase proc C
	%GET_NT_BASE Eax
	ret
LdrGetNtBase endp

	include Img.asm
	
; +
;
;      .
;
LdrParseCallback proc uses ebx esi pSum:ULONG, pN:PULONG, $Name:PSTR, S1ze:ULONG
	mov eax,$Name
	mov ecx,S1ze
	mov edx,pSum
	.if (Ecx > 6) && W[Eax] == 'wZ'
		mov eax,pN
		add D[edx],ecx
		inc D[eax]
	.else
		test eax,eax
	.endif
	ret
LdrParseCallback endp

; +
;
;   .
;
LdrGenerateZwList proc uses ebx esi edi
Local ImageHeader:PIMAGE_NT_HEADERS
Local ExportDirectory:PIMAGE_EXPORT_DIRECTORY
Local NumberOfNames:ULONG
Local S1ze:ULONG, N:ULONG
Local pNtList:PVOID
	mov ebx,g_NtView
	mov S1ze,0
	mov N,0
	invoke LdrImageQueryEntryFromHash, Ebx, addr S1ze, LdrParseCallback, addr N, NULL
	mov ecx,N
	shl ecx,3	; NTID.Name = 8
	add S1ze,ecx
	invoke ZwAllocateVirtualMemory, NtCurrentProcess, addr g_NtList, 0, addr S1ze, MEM_COMMIT, PAGE_READWRITE
	mov ecx,g_NtList
	test eax,eax
	mov pNtList,ecx
	jnz Exit
	invoke LdrImageNtHeader, Ebx, addr ImageHeader
	test eax,eax
	mov ecx,ImageHeader
	jnz Exit
	assume ecx:PIMAGE_NT_HEADERS
	mov eax,[ecx].OptionalHeader.DataDirectory.VirtualAddress
	test eax,eax
	jz Error
	add eax,ebx
	assume eax:PIMAGE_EXPORT_DIRECTORY	
	mov ExportDirectory,eax
	mov esi,[eax].AddressOfNames
	test esi,esi
	mov eax,[eax].NumberOfNames
	jz Error
	test eax,eax
	mov NumberOfNames,eax
	jz Error
	add esi,ebx
	xor edi,edi
	cld
Next:
	push esi
	push edi
	mov edx,D[esi]
	mov ecx,MAX_PATH
	add edx,ebx
	mov edi,edx
	xor eax,eax
	repne scasb
	not ecx
	add ecx,MAX_PATH
	.if (Ecx > 6) && W[Edx] == 'wZ'
		mov edi,pNtList
		mov esi,edx
		mov NTID.S1ze[edi],cx
		add edi,NTID.Nam3
		inc ecx
		rep movsb
		
		mov edx,D[esp]
		mov ecx,ExportDirectory
		assume ecx:PIMAGE_EXPORT_DIRECTORY
		mov eax,[ecx].AddressOfNameOrdinals
		add eax,ebx
		movzx edx,word ptr [2*edx + eax]
		.if Edi
			.if Edx >= [Ecx]._Base
				sub edx,[ecx]._Base
			.endif
			inc edx
		.endif
		mov esi,[ecx].AddressOfFunctions
		add esi,ebx
		mov ecx,D[4*edx + esi]
		mov edx,pNtList
		mov NTID.Rva[edx],ecx
		mov pNtList,edi
		add ecx,ebx
		cmp B[ecx],0B8H	; mov eax,Id
		mov eax,D[ecx + 1]
		jne Error
		mov NTID.Id[edx],ax
	.endif
	pop edi
	pop esi
	inc edi
	add esi,4
	dec NumberOfNames
	jnz Next
	mov ecx,pNtList
	xor eax,eax
	mov g_NtListN,ecx
Exit:
	ret
Error:
	mov eax,STATUS_UNSUCCESSFUL
	jmp Exit
LdrGenerateZwList endp

; +
;
;      ID.
;
FltIdToNTID proc uses ebx Id:ULONG
	cmp g_Init,FALSE
	je Fail
	mov eax,g_NtList
	mov ecx,g_NtListN
	mov ebx,Id
@@:
	movzx edx,NTID.S1ze[eax]
	cmp NTID.Id[eax],bx
	je Exit
	lea eax,[eax + edx + NTID.Nam3 + 1]
	cmp eax,ecx
	jb @b
Fail:
	xor eax,eax
Exit:
	ret
FltIdToNTID endp

; +
;
; .
;
FltGate proc C
	mov edx,0BADC0DEH
	Int 2Eh
	ret
FltGate endp

PEB_DBG_FLAG	equ X86_PAGE_SIZE - 4
TEB_DBG_FLAG	equ X86_PAGE_SIZE - 4

%TSTART macro
	mov D fs:[TEB_DBG_FLAG],FALSE
endm

%TSTOP macro
	mov D fs:[TEB_DBG_FLAG],TRUE
endm

Filter proc C
	pushfd
	pushad
	%TSTOP
	.if g_Init
		invoke FltIdToNTID, Eax
		.if Eax
			add eax,NTID.Nam3
			invoke DbgPrint, Eax
		.endif
	.else
		Int 3
	.endif
	%TSTART
	popad
	popfd
	mov edx,0BADC0DEH
	Int 2Eh
Filter endp

DllEntry proc DllHandle:HANDLE, Reason:ULONG, Context:PVOID
Local S1ze:ULONG
	.if Reason == DLL_PROCESS_ATTACH
		invoke LdrGetNtBase
		mov g_NtBase,eax
		invoke LdrMapViewOfImage, Eax, addr g_NtView
		test eax,eax
		jl Exit
		invoke LdrGenerateZwList
		.if !Eax
			mov ecx,fs:[TEB.Peb]
			mov g_Init,TRUE
			mov D[ecx + PEB_DBG_FLAG],offset Filter
		.endif
	.elseif Reason == DLL_PROCESS_DETACH
		mov ecx,fs:[TEB.Peb]
		mov S1ze,NULL
		mov D[ecx + PEB_DBG_FLAG],NULL
;		invoke ZwUnmapViewOfSection, NtCurrentProcess, g_NtView
;		invoke ZwFreeVirtualMemory, NtCurrentProcess, addr g_NtList, addr S1ze, MEM_RELEASE
	.endif
Exit:
	mov eax,TRUE
	ret
DllEntry Endp
end DllEntry